<?php

/* ------------------------------------------------------------------------
 * Bang2Joom K2 Calendar for Joomla 2.5+
 * ------------------------------------------------------------------------
 * Copyright (C) 2011-2012 Bang2Joom. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: Bang2Joom
 * Websites: http://www.bang2joom.com
  ------------------------------------------------------------------------
 */

defined('_JEXEC') or die;
require(dirname(__FILE__) . DIRECTORY_SEPARATOR . "helper_parameters.php");
require_once(JPATH_SITE . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_k2' . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'route.php');
if (isset($_GET["auth"]) and isset($_GET["last_refresh"]) and isset($_GET['mid']) and $_GET['mid']==$module->id) {
    header( "Expires: Mon, 26 Jul 1997 05:00:00 GMT" ); 
	header( "Last-Modified: ".gmdate( "D, d M Y H:i:s" )."GMT" ); 
	header( "Cache-Control: no-cache, must-revalidate" ); 
	header( "Pragma: no-cache" );
	header( "Content-Type: text/html; charset=utf-8" );
    $auth = $_GET["auth"];
    $last_refresh = $_GET["last_refresh"];
    if ($auth == md5("NOW" . $last_refresh)) {
        $db = JFactory::getDBO();
        $config = JFactory::getConfig();
        $offset = $config->get('config.offset');
        $now_date = JFactory::getDate('now', $offset);
        $now = $now_date->toSQL();
        $nullDate = $db->getNullDate();
        $current_date = $_GET["current_date"];
        $get_items = $_GET["get_items"];
        
        // Get Items for AJAX
        if ($get_items && $calendar_mode == 1){
            $query = "select #__k2_items.id as id, #__k2_items.title as title, #__k2_items.alias as alias, #__k2_items.introtext, date(#__k2_items.".$date_type.") as created, #__k2_items.".$date_type." as item_date, #__k2_items.publish_up as publish_date, catid as cat_id, #__k2_categories.alias as cat_alias
            from #__k2_items 
            left join #__k2_categories ON #__k2_items.catid = #__k2_categories.id 
            where #__k2_items.published=1 
            and #__k2_items.trash=0 
            and #__k2_categories.published = 1 
            and date(#__k2_items.".$date_type.") = '".$current_date."' ";
            if (!$future_days){
                $query .= "and ( #__k2_items.".$date_type." = " . $db->Quote($nullDate) . " OR #__k2_items.".$date_type." <= " . $db->Quote($now) . " )
                           and ( #__k2_items.publish_down = " . $db->Quote($nullDate) . " OR #__k2_items.publish_down >= " . $db->Quote($now) . " ) ";
            }
            if (count($k2_categories) && !$k2_filter) {
                $categories_string = "";
                for ($i = 0; $i < count($k2_categories); $i++) {
                    $categories_string .= $k2_categories[$i] . ", ";
                }
                $categories_string = substr($categories_string, 0, -2);
                if ($inherit_children)
                    $query .= " and (catid in (" . $categories_string . ") or parent in (" . $categories_string . "))";
                else
                    $query .= " and catid in (" . $categories_string . ") ";
            }
            $query .= " order by #__k2_items.".$date_type." desc";
            $query .= " limit 0,".$maximum_items;
            $db->setQuery($query);
            $rows = $db->loadObjectList();
            if ($db->getErrorNum()) {
                echo $db->stderr();
                return false;
            }
            $items = array();
            foreach ( $rows as $value ) {
                $value->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($value->id . ':' . urlencode($value->alias), $value->cat_id . ':' . urlencode($value->cat_alias))));
                $items[] = $value;
            }
            
            
            $li = "";
            $info='';
            $info_block = '';
            foreach ($items as $item) {
                $info_block = '';
                $li .= '<li data-k2id="' . $item->id . '">';
                if ($date_view or $title_view or $introtext_view) {
                    $seq = array();
                    $seq[$date_view_pos]='';
                    $seq[$title_view_pos]='';
                    $seq[$introtext_view_pos]='';
                    
                    if ($date_view) {
                        $item->item_date = JHTML::_('date', $item->item_date, $date_format, true, false);
                        $seq[$date_view_pos] .= '<div class = "date_view fl'.$date_view_float.'">';
                        $seq[$date_view_pos] .= $item->item_date;
                        $seq[$date_view_pos] .= '</div>';
                    }
                    
                    if ($title_view) {
                        $use_link = true;
                        if (strpos($item->link, ':future') !== false) {
                           $use_link = false;
                        }
                        $this_moment = JHTML::_('date', strtotime($db->Quote($now)), 'Y-m-d H:i', true, false);
                        if (strtotime($item->publish_date) > strtotime($this_moment)) {
                           $use_link = false;
                        }
                        
                        $seq[$title_view_pos] .= '<div class = "title_view fl'.$title_view_float.'">';
                        if ($use_link){
                            $seq[$title_view_pos] .= '<a href="'.$item->link.'">';
                        }
                        $text = $item->title;
                        if ($title_limit != "" and (int) $title_limit >= 0) {
                            $text = strip_tags($text);
                            $text = preg_replace('/\s+/', ' ', $text);
                            if ($title_limit_by == 0) {
                                $words = explode(" ", $text);
                                $result = '';
                                $i = 1;
                                foreach ($words as $word) {
                                    if ($i++ > $title_limit)
                                        break;
                                    $result.=$word . " ";
                                }
                                $result = substr($result, 0, -1);
                            }else {
                                $result = substr($text, 0, $title_limit);
                                for ($i = $title_limit; $i < strlen($text); $i++) {
                                    if ($text{$i} == ' ' || $text{$i} == '\r' || $text{$i} == '\n')
                                        break;
                                    $result.=$text{$i};
                                }
                            }
                        }else {
                            $result = $text;
                        }
                        if ($title_end == "0")
                            {}
                        else if ($title_end == "1") {
                            $result =  $result . ".";
                        } else if ($title_end == "2") {
                            $result = $result . "...";
                        }
                        $seq[$title_view_pos] .= $result;
                        if ($use_link){
                            $seq[$title_view_pos] .= '</a>';
                        }
                        $seq[$title_view_pos] .= '</div>';
                    }
                    
                    if ($introtext_view) {
                        $seq[$introtext_view_pos] .= '<div class="introtext_view fl'.$introtext_view_float.'">';
                        $text = $item->introtext;
                        if ($introtext_limit != "" and (int) $introtext_limit >= 0) {
                            $text = strip_tags($text);
                            $text = preg_replace('/\s+/', ' ', $text);
                            if ($introtext_limit_by == 0) {
                                $words = explode(" ", $text);
                                $result = '';
                                $i = 1;
                                foreach ($words as $word) {
                                    if ($i++ > $introtext_limit)
                                        break;
                                    $result.=$word . " ";
                                }
                                $result = substr($result, 0, -1);
                            }else {
                                $result = substr($text, 0, $introtext_limit);
                                for ($i = $introtext_limit; $i < strlen($text); $i++) {
                                    if ($text{$i} == ' ' || $text{$i} == '\r' || $text{$i} == '\n')
                                        break;
                                    $result.=$text{$i};
                                }
                            }
                        }else {
                            $result = $text;
                        }
                        if ($introtext_end == "0"){}
                            
                        else if ($introtext_end == "1") {
                            $result =  $result . ".";
                        } else if ($introtext_end == "2") {
                            $result = $result . "...";
                        }
                        $seq[$introtext_view_pos] .= $result;
                        $seq[$introtext_view_pos] .= '</div>';
                    }

                    ksort($seq);
                    $info_block .= '<div class="info_block">';
                    foreach ($seq as $block) {
                        $info_block .= $block;
                        $info_block .= '<div class="b2j_clearfix"></div>';
                    }
                    $info_block .= '</div>';
                }    
                $li .= $info_block;
                $li .= '<div class="b2j_clearfix"></div>';
                $li .= '</li>';
            }
            
            
            echo '{b2j_mark1_'.$module->id.'}'.$li.'{b2j_mark2_'.$module->id.'}';
        }      
        // Blog Calendar
        if (!$get_items && $calendar_mode == 0){
            $query = "select count(#__k2_items.id) as c, date(#__k2_items.".$date_type.") as created
            from #__k2_items 
            left join #__k2_categories ON #__k2_items.catid = #__k2_categories.id 
            where #__k2_items.published=1 
            and #__k2_items.trash=0 
            and #__k2_categories.published = 1 
            and created >= '".$current_date . '-01'."'
            and created <= '".$current_date . '-31'."' ";
            if (!$future_days){
                $query .= "and ( #__k2_items.".$date_type." = " . $db->Quote($nullDate) . " OR #__k2_items.".$date_type." <= " . $db->Quote($now) . " )
                           and ( #__k2_items.publish_down = " . $db->Quote($nullDate) . " OR #__k2_items.publish_down >= " . $db->Quote($now) . " ) ";
            }
            if ($k2_category !="") {
                $query .= " and catid = ".$k2_category;
            }
            $query .= " group by date(#__k2_items.".$date_type.")";
            
            $db->setQuery($query);
            $rows = $db->loadObjectList();
            if ($db->getErrorNum()) {
                echo $db->stderr();
                return false;
            }
            $items = array();
            foreach ($rows as $item) {
                $items[] = $item->created . "*" . $item->c;
            }
            echo '{b2j_mark1_'.$module->id.'}'.stripslashes(json_encode($items)).'{b2j_mark2_'.$module->id.'}';
        }
        // AJAX Calendar
        if (!$get_items && $calendar_mode == 1){
            $query = "select count(#__k2_items.id) as c, date(#__k2_items.".$date_type.") as created
            from #__k2_items 
            left join #__k2_categories ON #__k2_items.catid = #__k2_categories.id 
            where #__k2_items.published=1 
            and #__k2_items.trash=0 
            and #__k2_categories.published = 1 
            and created >= '".$current_date . '-01'."'
            and created <= '".$current_date . '-31'."' ";
            if (!$future_days){
                $query .= "and ( #__k2_items.".$date_type." = " . $db->Quote($nullDate) . " OR #__k2_items.".$date_type." <= " . $db->Quote($now) . " )
                           and ( #__k2_items.publish_down = " . $db->Quote($nullDate) . " OR #__k2_items.publish_down >= " . $db->Quote($now) . " ) ";
            }
            if (count($k2_categories) && !$k2_filter) {
                $categories_string = "";
                for ($i = 0; $i < count($k2_categories); $i++) {
                    $categories_string .= $k2_categories[$i] . ", ";
                }
                $categories_string = substr($categories_string, 0, -2);
                if ($inherit_children)
                    $query .= " and (catid in (" . $categories_string . ") or parent in (" . $categories_string . "))";
                else
                    $query .= " and catid in (" . $categories_string . ") ";
            }
            $query .= " group by date(#__k2_items.".$date_type.")";
            $db->setQuery($query);
            $rows = $db->loadObjectList();
            if ($db->getErrorNum()) {
                echo $db->stderr();
                return false;
            }
            $items = array();
            foreach ($rows as $item) {
                $items[] = $item->created . "*" . $item->c;
            }
            echo '{b2j_mark1_'.$module->id.'}'.stripslashes(json_encode($items)).'{b2j_mark2_'.$module->id.'}';
        }      
    }
    exit;
}

require(JModuleHelper::getLayoutPath('mod_b2j_k2_calendar', 'default'));